<script setup lang="ts">
    import { isDefined } from '@/shared/helpers/types'
    import { ButtonAction } from '../entities/ButtonAction'

    interface Props {
        icon?: string
        buttonActions: ButtonAction[]
        dataCy?: string
    }
    withDefaults(defineProps<Props>(), {
        icon: undefined,
        dataCy: undefined,
    })
</script>

<template>
    <template v-if="buttonActions.length === 0">
        <span :data-cy="dataCy">
            <slot></slot>
        </span>
    </template>

    <a
        v-if="
            buttonActions.length === 1 &&
            typeof buttonActions[0].route === 'string'
        "
        :href="buttonActions[0].route"
        :data-cy="dataCy"
    >
        <slot></slot>
        <v-icon v-if="isDefined(icon)" size="small" class="ms-1">{{
            icon
        }}</v-icon>
    </a>
    <router-link
        v-if="
            buttonActions.length === 1 &&
            typeof buttonActions[0].route !== 'string'
        "
        :to="buttonActions[0].route"
        :data-cy="dataCy"
    >
        <slot></slot>
        <v-icon v-if="isDefined(icon)" size="small" class="ms-1">{{
            icon
        }}</v-icon>
    </router-link>
    <v-bottom-sheet v-if="buttonActions.length > 1" :data-cy="dataCy">
        <template #activator="{ props }">
            <a href="#" v-bind="props" :data-cy="dataCy" @click.prevent>
                <slot></slot>
                <v-icon v-if="isDefined(icon)" size="small" class="ms-1">{{
                    icon
                }}</v-icon>
            </a>
        </template>

        <v-list data-cy="button-actions-list">
            <v-list-item
                v-for="buttonAction in buttonActions"
                :key="buttonAction.route.toString()"
                :prepend-icon="buttonAction.icon"
                :title="buttonAction.label"
                :to="
                    typeof buttonAction.route !== 'string'
                        ? buttonAction.route
                        : undefined
                "
                :href="
                    typeof buttonAction.route === 'string'
                        ? buttonAction.route
                        : undefined
                "
            ></v-list-item>
        </v-list>
    </v-bottom-sheet>
</template>
